// **********************************************************************
//
// Copyright (c) 2003-2018 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.7.1
//
// <auto-generated>
//
// Generated from file `Session.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package Glacier2;

/**
 * An administrative session control object, which is tied to the
 * lifecycle of a {@link Session}.
 *
 * @see Session
 *
 **/
public interface _SessionControlOperations
{
    /**
     * Access the object that manages the allowable categories
     * for object identities for this session.
     *
     * @param current The Current object for the invocation.
     * @return A StringSet object.
     *
     **/
    StringSetPrx categories(Ice.Current current);

    /**
     * Access the object that manages the allowable adapter identities
     * for objects for this session.
     *
     * @param current The Current object for the invocation.
     * @return A StringSet object.
     *
     **/
    StringSetPrx adapterIds(Ice.Current current);

    /**
     * Access the object that manages the allowable object identities
     * for this session.
     *
     * @param current The Current object for the invocation.
     * @return An IdentitySet object.
     *
     **/
    IdentitySetPrx identities(Ice.Current current);

    /**
     * Get the session timeout.
     *
     * @param current The Current object for the invocation.
     * @return The timeout.
     *
     **/
    int getSessionTimeout(Ice.Current current);

    /**
     * Destroy the associated session.
     *
     * @param current The Current object for the invocation.
     **/
    void destroy(Ice.Current current);
}
